{--------------------------------------------------------}

{
{    VoxTube - utilitrio de acessibilizao do YouTube
{
{    Procedimentos de download
{
{    Autor:  Fabiano Ferreira
{
{    Em fevereiro de 2013
{
{--------------------------------------------------------}

unit vtRede;

interface
uses dvcrt, dvwin, dvinet, vtmsg, sysutils;

function stringToURL(s: string): string;
function URLToString(s: string): string;
function download(link, nomeArq: string) : boolean;
function pedeAoYoutube (pedidoHTTP: string): string;

implementation

{--------------------------------------------------------}
{   transforma string para a codificao usada em URLs
{--------------------------------------------------------}

function stringToURL(s: string): string;
var i: integer;
begin
    result := '';
    for i := 1 to length(s) do
        begin
            if s[i] in ['0'..'9', 'a'..'z', 'A'..'Z', '.', '-', '_', '~'] then
                result := result + s[i]
            else
                result := result + '%' + intToHex(ord(s[i]), 2);
        end;
end;

{--------------------------------------------------------}
{   transforma string para a codificao usada em URLs
{--------------------------------------------------------}

function URLToString(s: string): string;

    function hex(c: char): integer;
    begin
        if c in ['0'..'9'] then result := ord(c) - ord('0')
        else
        if c in ['a'..'f'] then result := ord(c) - ord('a') + 10
        else
        if c in ['A'..'F'] then result := ord(c) - ord('A') + 10
        else
            result := 0;
    end;

var i, n: integer;

begin
    result := '';
    i := 1;
    while i <= length(s) do
        begin
            if (s[i] = '%') and (i <= length(s)-2) then
                begin
                    n := (hex(s[i+1]) shl 4) + hex(s[i+1]);
                    result := result + chr(n);
                    i := i + 3;
                end
            else
                begin
                    result := result + s[i];
                    i := i + 1;
                end;
        end;
end;

{--------------------------------------------------------}
{   faz download do vdeo
{--------------------------------------------------------}

function download(link, nomeArq: string) : boolean;
const
    UM_K = 1024;

var
    sock : integer;
    buflocal : array[1..1024] of char;
    buf : pbufrede;
    host : string;
    arq : file;
    aTransferir, escritos, transferidos, porcentagem, tamanho, aReceber : integer;
    s: string;
    i: integer;
    c, c2 : char;
    jagravados : integer;
    status: string;
    codret, erroVal: integer;
    comClek: boolean;
    x, sg, sgant: word;

label montacabec, fim, fimRede;

begin
    download := false;
    jagravados := 0;

    if (link = '') or (nomearq = '') then exit;

    assignfile(arq, nomearq);

montaCabec:
    link := copy (link, pos('://', link)+3, 999);
    i := pos ('/', link);
    host := copy (link, 1, i-1);
    delete (link, 1, i-1);
    if link = '' then link := '/';

    abreWinsock;
    sock := abreConexaossl(host,443);
    writelnRede(sock,'GET '+ link +' HTTP/1.1');
    writelnRede(sock,'Host: '+host);
    if fileexists (nomearq) then
        begin
            filemode := 2;
            reset(arq, 1);

            jagravados := filesize(arq);
            Writelnrede (sock,'Range: bytes='+inttostr(jagravados)+'-');
        end;

    writelnRede(sock,'');

    buf := inicBufRede(sock);
    readlnBufRede(buf, s, 0);

    status := copy (s, pos(' ', s) + 1, 3);
    val (status, codret, erroVal);
    if erroVal <> 0 then codRet := 404;
    case codRet of
        400: begin
                mensagem ('VT_E400', 1);   {'Erro http400: Requisio http no foi bem formulada.'}
                exit;
             end;
        404: begin
                mensagem ('VT_E404', 1);   {'Erro http404: Pgina no encontrada.'}
                exit;
             end;
        206: mensagem ('VTRETOMA', 1);     {'Retomando download'}

        200: begin
                {$I-} rewrite (arq, 1); {$I+}
                if ioresult <> 0 then
                    begin
                        mensagem ('VTERRCRI', 1);
                            {'Erro na criao do arquivo.  Verifique o nome e espao em disco.'}
                        aReceber := 999999999;
                        goto fimRede;
                    end;
             end;
    end;

    tamanho := 0;
    repeat
        readlnBufRede(buf, s, 0);
        if uppercase (copy(s, 1, 9)) = 'LOCATION:' then
            begin
                link := trim (copy(s, 10, length(s)));
                fimBufRede(buf);
                fechaConexao(sock);
                fechaWinsock;
                goto montaCabec;
            end;
        if uppercase (copy(s, 1, 15)) = 'CONTENT-LENGTH:' then
            tamanho := strToInt(trim(copy(s, 16, length(s))));
    until s = '';

    if jagravados > 0 then seek(arq,jagravados);

    if jagravados > 0 then
        begin
            escritos := jagravados;
            transferidos := jagravados;
        end
    else
        escritos := 0;

    aReceber := tamanho;

    comClek := false;
    getTime (x, x, sgant, x);
    while aReceber >= 1 do
        begin
            if comClek then
                begin
                    getTime (x, x, sg, x);
                    if sg <> sgant then
                        begin
                            sgant := sg;
                            sintCarac (' ');
                        end;
                end;

            if aReceber >= 1024 then
                aTransferir := 1024
            else
                aTransferir := aReceber;
            for i := 1 to aTransferir do
                lecaracbufrede(buf,buflocal[i]);
            {$I-}
            blockwrite(arq, buflocal, aTransferir, transferidos);
            {$I+}
            if (ioresult <> 0) or (transferidos <> aTransferir) then
                begin
                    mensagem ('VTERRGRV', 1);
                            {'Erro de gravao. Verifique o espao em disco.'}
                    goto fim;
                end;

            aReceber := aReceber - aTransferir;
            escritos := escritos + transferidos;

            if keypressed then
                begin
                    c := readkey;
                    if c = ENTER then
                        begin
                            porcentagem := trunc((escritos /(tamanho+jagravados) ) * 100);
                            if tamanho+jagravados >= 1048576 then
                                sintWrite (inttostr(porcentagem)+'% de '
                                    + inttostr((tamanho+jagravados) div 1024 div 1024)
                                    +'MB; '
                                    + inttostr ((tamanho+jagravados) div 1024 div 1024 * 1000 *
                                      porcentagem div 100) + ' KB')
                            else
                                sintWrite (inttostr(porcentagem) + '% de '
                                    + inttostr ((tamanho+jagravados) div 1024)+'KB; '
                                    + inttostr ((tamanho + jagravados) div 1024 *
                                      porcentagem div 100) + ' KB');

                            mensagem ('VTRCAPRO', 0); {' recebidos aproximadamente em '}
                            sintWriteln (nomearq);
                        end
                    else
                    if c = ' ' then
                        comClek := not comClek
                    else
                    if c = ESC then
                        begin
                            mensagem ('VTPARDWN', 0);   {'Deseja parar o download? '}
                            c2 := sintReadkey;
                            writeln(c2);
                            if upcase(c2) = 'S' then
                                begin
                                    mensagem ('VTDWNINT', 2);  {'O download foi interrompido.'}
                                    goto fim;
                                end;
                        end;
                end;
        end;
fim:
    {$I-}
    closefile(arq);
    {$I+}
    if ioresult <> 0 then;  // j mostrou erro antes

fimRede:
    fimbufrede(buf);
    fechaconexao(sock);
    fechawinsock;
    if areceber <= 1 then download := true;
end;

{--------------------------------------------------------}
{              manda um pedido ao Youtube
{--------------------------------------------------------}

function pedeAoYoutube (pedidoHTTP: string): string;
var
    pbuf: PbufRede;
    s: string;
    c: char;
    ok: boolean;
    sock: integer;
begin
    abreWinsock;
    sock := abreConexaoSsl ('www.youtube.com', 443);
    if sock <= 0 then
        begin
            mensagem('VTNAOCON', 1); {'No consegui realizar a conexo.'}
            result := '';
            exit;
        end;

    writelnRede (sock, 'GET ' + pedidoHttp + ' HTTP/1.0');
    writelnRede (sock, 'Host: ' + 'www.youtube.com');
    writelnRede (sock, 'User-Agent: Voxtube 3.0');
    writelnRede (sock, 'Accept-Language: pt-br');
    writelnRede (sock, 'UA-CPU: x86');
    writelnRede (sock, '');

    pbuf := inicBufRede (sock);
    repeat
        ok := readlnBufRede(pbuf, s, 500);
    until (not ok) or (s = '');

    s := '';
    repeat
        while not temDadoBufRede(pbuf) do delay (100);
        ok := leCaracBufRede(pbuf, c);
        if ok then s := s + c;
    until not ok;

    fimBufRede (pbuf);
    fechaConexao (sock);
    result := s;
    fechaWinsock;
end;


end.
